"use strict";
exports.__esModule = true;
var utils_1 = require("./utils");
var config_1 = require("./config");
function withCookie(instance, cc) {
    var _a = config_1.getConfig(cc), noCookie = _a.noCookie, ssCookie = _a.ssCookie, defaultExp = _a.defaultExp;
    Object.keys(instance).forEach(function (key) {
        var methodType = Object.getOwnPropertyDescriptor(instance, key);
        if (typeof instance[key] !== "function" &&
            methodType &&
            !methodType.get &&
            !methodType.set) {
            var blocksave_1 = noCookie && noCookie.indexOf(key) !== -1;
            var cookieName_1 = key + "_ck";
            var keyV_1 = (!blocksave_1 && utils_1.getCookie(cookieName_1, ssCookie)) || instance[key];
            if (blocksave_1) {
                Object.defineProperty(instance, key, {
                    value: keyV_1,
                    enumerable: true
                });
            }
            else {
                Object.defineProperty(instance, key, {
                    set: function (value) {
                        keyV_1 = value;
                        if (!blocksave_1) {
                            utils_1.setCookie(cookieName_1, value, defaultExp);
                        }
                    },
                    get: function () {
                        return keyV_1;
                    }
                });
            }
        }
    });
    return instance;
}
exports.withCookie = withCookie;
//# sourceMappingURL=main.js.map